[BACK]Return to fw_install.sh CVS log [TXT][DIR] Up to [local] / openbsd / fw_update

Diff for /openbsd/fw_update/fw_install.sh between version 1.7 and 1.78

version 1.7, 2021/10/14 03:00:02 version 1.78, 2021/12/11 21:19:24
Line 1 
Line 1 
 #!/bin/ksh  #!/bin/ksh
 set -e  #       $OpenBSD$
   #
   # Copyright (c) 2021 Andrew Hewus Fresh <afresh1@openbsd.org>
   #
   # Permission to use, copy, modify, and distribute this software for any
   # purpose with or without fee is hereby granted, provided that the above
   # copyright notice and this permission notice appear in all copies.
   #
   # THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
   # WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
   # MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
   # ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
   # WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
   # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
   # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
   
 scan_dmesg() {  set -o errexit -o pipefail -o nounset
         # no bsort for now  export PATH=/usr/bin:/bin:/usr/sbin:/sbin
         sed -n "$1" /var/run/dmesg.boot  
 }  
   
 installed_firmware() {  CFILE=SHA256.sig
         for fw in ${PKGDIR}/$1-firmware*; do  DESTDIR=${DESTDIR:-}
                 [ -e "$fw" ] || continue  FWPATTERNS="${DESTDIR}/usr/share/misc/firmware_patterns"
                 echo ${fw##*/}  
         done  
 }  
   
 # do_as, unpriv, and unpriv2 are from install.sub  VNAME=${VNAME:-$(sysctl -n kern.osrelease)}
   VERSION=${VERSION:-"${VNAME%.*}${VNAME#*.}"}
   
 # Run a command ($2+) as unprivileged user ($1).  HTTP_FWDIR="$VNAME"
 # Take extra care that after "cmd" no "user" processes exist.  VTYPE=$( sed -n "/^OpenBSD $VNAME\([^ ]*\).*$/s//\1/p" \
 #      /var/run/dmesg.boot | sed '$!d' )
 # Optionally:  [[ $VTYPE == -!(stable) ]] && HTTP_FWDIR=snapshots
 #       - create "file" and chown it to "user"  
 #       - after "cmd", chown "file" back to root  
 #  
 # Usage: do_as user [-f file] cmd  
 do_as() {  
         (( $# >= 2 )) || return  
   
         local _file _rc _user=$1  FWURL=http://firmware.openbsd.org/firmware/${HTTP_FWDIR}
         shift  FWPUB_KEY=${DESTDIR}/etc/signify/openbsd-${VERSION}-fw.pub
   
         if [[ $1 == -f ]]; then  LOCALSRC=
                 _file=$2  
                 shift 2  tmpdir() {
           local _i=1 _dir
   
           # If we're not in the installer,
           # we have mktemp and a more hostile environment
           if [ -x /usr/bin/mktemp ]; then
                   _dir=$( mktemp -d "${1}-XXXXXXXXX" )
           else
                   until _dir="${1}.$_i.$RANDOM" && mkdir -- "$_dir" 2>/dev/null; do
                       ((++_i < 10000)) || return 1
                   done
         fi          fi
   
         if [[ -n $_file ]]; then          echo "$_dir"
                 >$_file  }
                 chown "$_user" "$_file"  
   fetch() {
           local _src="${FWURL}/${1##*/}" _dst=$1 _user=_file _exit
   
           # If we're not in the installer, we have su(1)
           # and doas(1) is unlikely to be configured.
           if [ -x /usr/bin/su ]; then
                   /usr/bin/su -s /bin/ksh "$_user" -c \
                       "/usr/bin/ftp -D 'Get/Verify' -Vm -o- '$_src'" > "$_dst"
                   _exit="$?"
           else
                   /usr/bin/doas -u "$_user" \
                       /usr/bin/ftp -D 'Get/Verify' -Vm -o- "$_src" > "$_dst"
                   _exit="$?"
         fi          fi
   
         doas -u "$_user" "$@"          if [ "$_exit" -ne 0 ]; then
         _rc=$?                  rm -f "$_dst"
                   echo "Cannot fetch $_src" >&2
                   return 1
           fi
   }
   
         while doas -u "$_user" kill -9 -1 2>/dev/null; do  verify() {
                 echo "Processes still running for user $_user after: $@"          # On the installer we don't get sha256 -C, so fake it.
                 sleep 1          if ! fgrep -qx "SHA256 (${1##*/}) = $( /bin/sha256 -qb "$1" )" "$CFILE"; then
                   echo "Checksum test for ${1##*/} failed." >&2
                   return 1
           fi
   }
   
   devices_needing_firmware() {
           local _d _m _grep _dmesgtail _last=''
   
           # When we're not in the installer, the dmesg.boot can
           # contain multiple boots, so only look in the last one
           _dmesgtail=$( sed -n 'H;/^OpenBSD/h;${g;p;}' /var/run/dmesg.boot )
   
           grep -v '^[[:space:]]*#' "$FWPATTERNS" |
               while read -r _d _m; do
                   _grep="grep"
                   [ "$_last" = "$_d" ] && continue
                   [ "$_m" ] || _m="^${_d}[0-9][0-9]* at "
                   [ "$_m" = "${_m#^}" ] && _grep="fgrep"
   
                   echo "$_dmesgtail" | $_grep -q "$_m" || continue
                   echo "$_d"
                   _last="$_d"
         done          done
   }
   
         [[ -n $_file ]] && chown root "$_file"  firmware_filename() {
           local _f
           _f="$( sed -n "s/.*(\($1-firmware-.*\.tgz\)).*/\1/p" "$CFILE" | sed '$!d' )"
           ! [ "$_f" ] && echo "Unable to find firmware for $1" >&2 && return 1
           echo "$_f"
   }
   
         return $_rc  firmware_devicename() {
           local _d="${1##*/}"
           _d="${_d%-firmware-*}"
           echo "$_d"
 }  }
   
 unpriv() {  installed_firmware() {
         do_as _sndio "$@"          for fw in "${DESTDIR}/var/db/pkg/$1-firmware"*; do
                   [ -e "$fw" ] || continue
                   echo "${fw##*/}"
           done
 }  }
   
 unpriv2() {  add_firmware () {
         do_as _file "$@"          local _f="${1##*/}"
           local _pkgdir="${DESTDIR}/var/db/pkg/${_f%.tgz}"
           ftp -D "Install" -Vmo- "file:${1}" |
                   tar -s ",^\+,${_pkgdir}/+," \
                       -s ",^firmware,${DESTDIR}/etc/firmware," \
                       -C / -zxphf - "+*" "firmware/*"
   
           # TODO: Should we mark these so real fw_update can -Drepair?
           ed -s "${_pkgdir}/+CONTENTS" <<EOL
   /^@comment pkgpath/ -1a
   @option manual-installation
   @option firmware
   @comment install-script
   .
   w
   EOL
 }  }
   
 VNAME=$(sysctl -n kern.osrelease)  delete_firmware() {
 VERSION="${VNAME%.*}${VNAME#*.}"          local _cwd _pkg="$1" _pkgdir="${DESTDIR}/var/db/pkg"
 FWDIR="$VNAME"  
   
 HTTP_FWDIR=$FWDIR          # TODO: Check hash for files before deleting
 set -- $(scan_dmesg "/^OpenBSD $VNAME\([^ ]*\).*$/s//\1/p")          echo "Uninstalling $_pkg"
 [[ $1 == -!(stable) ]] && HTTP_FWDIR=snapshots          _cwd="${_pkgdir}/$_pkg"
   
 FWURL=http://firmware.openbsd.org/firmware/${HTTP_FWDIR}          set -A _remove -- "${_cwd}/+CONTENTS" "${_cwd}"
 FWPUB_KEY=${DESTDIR}/etc/signify/openbsd-${VERSION}-fw.pub  
 PKGDIR=${DESTDIR}/var/db/pkg  
 PATTERNS="file:${0%/*}/firmware_patterns"  
   
 drivers=$(          while read -r c g; do
         last=''                  case $c in
         ftp -D "Detecting" -Vmo- $PATTERNS |                  @cwd) _cwd="${DESTDIR}$g"
         while read d m; do                    ;;
                 grep=grep                  @*) continue
                 [ "$last" = "$d" ] && continue                    ;;
                 [ "$m" ] || m="^$d[0-9][0-9]* at "                  *) set -A _remove -- "$_cwd/$c" "${_remove[@]}"
                 [ "$m" = "${m#^}" ] && grep=fgrep                    ;;
                 $grep -q "$m" /var/run/dmesg.boot || continue                  esac
                 echo $d          done < "${_pkgdir}/${_pkg}/+CONTENTS"
                 last=$d  
           # We specifically rm -f here because not removing files/dirs
           # is probably not worth failing over.
           for _r in "${_remove[@]}" ; do
                   if [ -d "$_r" ]; then
                           # Try hard not to actually remove recursively
                           # without rmdir on the install media.
                           [ "$_r/*" = "$( echo "$_r"/* )" ] && rm -rf "$_r"
                   else
                           rm -f "$_r"
                   fi
         done          done
 )  }
   
 if [ -z "$drivers" ]; then  usage() {
         echo "No devices found which need firmware files to be downloaded." >&2          echo "usage: fw_install [-d dir | -L dir] [driver | file [...]]"
         exit 0          exit 2
 fi  }
   
 tmpdir=${DESTDIR}/tmp/fw_update  INSTALL=true
 [ -e "$tmpdir" ] && rm -rf "$tmpdir"  DOWNLOAD=true
 mkdir -p "$tmpdir"  
 cd "$tmpdir"  
   
 # TODO: Drop privs during fetch and verify  while getopts dL name
 ftp -D Get -Vm "$FWURL/SHA256.sig"  do
          case "$name" in
          # "download only" means local dir and don't install
          d) LOCALSRC=. INSTALL=false ;;
          L) LOCALSRC=. ;;
          ?) usage 2 ;;
          esac
   done
   shift $((OPTIND - 1))
   
 # Probably should bundle the firmware sigfile on the installer,  # If we're installing from a local dir
 # although we can just get it from the recently installed system.  # we don't want to download anything
 if [ "$DESTDIR" ]; then  [ "$LOCALSRC" ] && "$INSTALL" && DOWNLOAD=false
         sigfile=$( sed -n '/^untrusted comment: verify with \(.*\)$/ { s//\1/p; q; }' SHA256.sig )  [ "$LOCALSRC" ] || LOCALSRC="$( tmpdir "${DESTDIR}/tmp/fw_install" )"
         if [ ! -e "/etc/signify/$sigfile" ] \  
           && [ -e "${DESTDIR}/etc/signify/$sigfile" ]; then  
                 cp -a "${DESTDIR}/etc/signify/$sigfile" "/etc/signify/$sigfile"  
         fi  
 fi  
   
 signify -Ve -x SHA256.sig -m - < SHA256.sig > SHA256  CFILE="$LOCALSRC/$CFILE"
   
 for d in $drivers; do  set -A devices -- "$@"
         firmware=$( sed -n "s/.*(\($d-firmware-.*\.tgz\)).*/\1/p" SHA256 )  
         installed=$( installed_firmware $d )  
   
         for i in $installed; do  [ "${devices[*]:-}" ] ||
                 if [ "$firmware" = "$i.tgz" ]; then      set -A devices -- $( devices_needing_firmware )
                         echo "Firmware for $d already installed ($installed)"  
                         continue 2  
                 fi  
         done  
   
         mkdir $d  if [ ! "${devices[*]:-}" ]; then
           echo "No devices found which need firmware files to be downloaded."
           exit
   fi
   
         # TODO: Drop privs during fetch and verify  if "$DOWNLOAD"; then
         ftp -D "Get/Verify" -Vmo- "$FWURL/$firmware" | sha256 -bph "$d/h" > "$firmware"          fetch "$CFILE"
         fgrep -qx "SHA256 ($firmware) = $(<$d/h)" SHA256          ! signify -qVep "$FWPUB_KEY" -x "$CFILE" -m "$CFILE" &&
               echo "Signature check of SHA256.sig failed" >&2 && exit 1
   fi
   
         # TODO: Check hash for files before deleting  for f in "${devices[@]}"; do
         if [ "$installed" ] && [ -e "${PKGDIR}/$installed/+CONTENTS" ]; then          d="$( firmware_devicename "$f" )"
                 echo "Uninstalling $installed"  
                 cwd=${PKGDIR}/$installed  
   
                 remove="${cwd}/+CONTENTS ${cwd}"          if [ "$f" = "$d" ]; then
                   f=$( firmware_filename "$d" || true )
                   [ "$f" ] || continue
                   f="$LOCALSRC/$f"
           elif ! "$INSTALL" && ! grep -Fq "($f)" "$CFILE" ; then
                   echo "Cannot download local file $f" >&2
                   exit 2
           fi
   
                 while read c g; do          set -A installed -- $( installed_firmware "$d" )
                         case $c in  
                         @cwd) cwd=$g  
                           ;;  
                         @*) continue  
                           ;;  
                         *)  remove="$cwd/$c $remove"  
                           ;;  
                         esac  
                 done < "${PKGDIR}/$installed/+CONTENTS"  
   
                 for r in $remove ; do          if "$INSTALL" && [ "${installed[*]:-}" ]; then
                         if [ -d "$r" ]; then                  for i in "${installed[@]}"; do
                                 # Try hard not to actually remove recursively                          if [ "${f##*/}" = "$i.tgz" ]; then
                                 # without rmdir on the install media.                                  echo "$i already installed"
                                 [ "$r/*" = $( echo "$r"/* ) ] && rm -rf "$r"                                  continue 2
                         else  
                                 rm -f "$r"  
                         fi                          fi
                 done                  done
         fi          fi
   
         # TODO: Add some details about the install to +CONTENTS like pkg_add          if [ -e "$f" ]; then
         # TODO: Or, maybe we save the firmware someplace and make pkg_add reinstall                  if "$DOWNLOAD"; then
         echo "Installing $firmware"                          echo "Verify existing ${f##*/}"
         tar -zxphf "$firmware" -C /etc "firmware/*"                          verify "$f" || continue
         mkdir -p ${PKGDIR}/${firmware%.tgz}/                  # else assume it was verified when downloaded
         tar -zxphf "$firmware" -C "${PKGDIR}/${firmware%.tgz}" "+*"                  fi
         ed -s "${PKGDIR}/${firmware%.tgz}/+CONTENTS" <<EOL          elif "$DOWNLOAD"; then
 /^@comment pkgpath/ -1a                  fetch  "$f" || continue
 @option manual-installation                  verify "$f" || continue
 @option firmware          elif "$INSTALL"; then
 @comment install-script                  echo "Cannot install ${f##*/}, not found" >&2
 .                  continue
 w          fi
 EOL  
           "$INSTALL" || continue
   
           if [ "${installed[*]:-}" ]; then
                   for i in "${installed[@]}"; do
                           delete_firmware "$i"
                   done
           fi
   
           add_firmware "$f"
 done  done
   

Legend:
Removed from v.1.7  
changed lines
  Added in v.1.78

FreeBSD-CVSweb <freebsd-cvsweb@FreeBSD.org>